/**
 * Intellidrone API
 * This ios Intellidrone API designed by [Singleton](http://singleton.com.ar).You  can find out more about Swagger at [Singleton Web Page](http://singleton.com.ar) or on [Intellidrone Web Page](http://robotagro.com).
 *
 * OpenAPI spec version: 1.0.0
 * Contact: soporte@singleton.com.ar
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['/ApiClient', '/models/Actividades', '/models/DeletedResponse', '/models/Error', '/models/UploadResponse', '/models/Vacas'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../models/Actividades'), require('../models/DeletedResponse'), require('../models/Error'), require('../models/UploadResponse'), require('../models/Vacas'));
  } else {
    // Browser globals (root is window)
    if (!root.intellidrone_api_client_js) {
      root.intellidrone_api_client_js = {};
    }
    root.intellidrone_api_client_js.ActividadesApi = factory(root.intellidrone_api_client_js.ApiClient, root.intellidrone_api_client_js.Actividades, root.intellidrone_api_client_js.DeletedResponse, root.intellidrone_api_client_js.Error, root.intellidrone_api_client_js.UploadResponse, root.intellidrone_api_client_js.Vacas);
  }
}(this, function(ApiClient, Actividades, DeletedResponse, Error, UploadResponse, Vacas) {
  'use strict';

  /**
   * Actividades service.
   * @module /api/ActividadesApi
   * @version 1.0.0
   */

  /**
   * Constructs a new ActividadesApi.
   * @alias module:/api/ActividadesApi
   * @class
   * @param {module:/ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:/ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Add one Actividad.
     * Add one Actividad.
     * @param {module:models/Actividades} actividad
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:models/Vacas} and HTTP response
     */
    this.addActividadWithHttpInfo = function(actividad) {
      var postBody = actividad;

      // verify the required parameter 'actividad' is set
      if (actividad === undefined || actividad === null) {
        throw new Error("Missing the required parameter 'actividad' when calling addActividad");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['appToken', 'userToken'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Vacas;

      return this.apiClient.callApi(
        '/Actividades', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    };

    /**
     * Add one Actividad.
     * Add one Actividad.
     * @param {module:models/Actividades} actividad
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:models/Vacas}
     */
    this.addActividad = function(actividad) {
      return this.addActividadWithHttpInfo(actividad)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    };


    /**
     * Add actividades from a file.
     * Add actividades from a file.
     * @param {Object} opts Optional parameters
     * @param {File} opts.upfile The file to upload.
     * @param {String} opts.userId id of user. Only for admin users.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:models/UploadResponse} and HTTP response
     */
    this.addActividadesWithHttpInfo = function(opts) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        userId: opts['userId'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        upfile: opts['upfile'],
      };

      var authNames = ['appToken', 'userToken'];
      var contentTypes = ['multipart/form-data'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = UploadResponse;

      return this.apiClient.callApi(
        '/Actividades/upload', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    };

    /**
     * Add actividades from a file.
     * Add actividades from a file.
     * @param {Object} opts Optional parameters
     * @param {File} opts.upfile The file to upload.
     * @param {String} opts.userId id of user. Only for admin users.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:models/UploadResponse}
     */
    this.addActividades = function(opts) {
      return this.addActividadesWithHttpInfo(opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    };


    /**
     * Delete one Actividad.
     * Delete one Actividades.
     * @param {String} id id to delete
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:models/DeletedResponse} and HTTP response
     */
    this.deleteActividadWithHttpInfo = function(id) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling deleteActividad");
      }


      var pathParams = {
        id: id,
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['appToken', 'userToken'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = DeletedResponse;

      return this.apiClient.callApi(
        '/Actividades/{id}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    };

    /**
     * Delete one Actividad.
     * Delete one Actividades.
     * @param {String} id id to delete
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:models/DeletedResponse}
     */
    this.deleteActividad = function(id) {
      return this.deleteActividadWithHttpInfo(id)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    };


    /**
     * Edit one Actividad.
     * Edit one Actividad
     * @param {module:models/Vacas} lote
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:models/Actividades} and HTTP response
     */
    this.editActividadWithHttpInfo = function(lote) {
      var postBody = lote;

      // verify the required parameter 'lote' is set
      if (lote === undefined || lote === null) {
        throw new Error("Missing the required parameter 'lote' when calling editActividad");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['appToken', 'userToken'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Actividades;

      return this.apiClient.callApi(
        '/Actividades', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    };

    /**
     * Edit one Actividad.
     * Edit one Actividad
     * @param {module:models/Vacas} lote
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:models/Actividades}
     */
    this.editActividad = function(lote) {
      return this.editActividadWithHttpInfo(lote)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    };


    /**
     * Get one Actividad.
     * Get one Actividades.
     * @param {String} id id to delete
     * @param {Object} opts Optional parameters
     * @param {String} opts.userId id of user. Only for admin users.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:models/Actividades} and HTTP response
     */
    this.getActividadByIdWithHttpInfo = function(id, opts) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling getActividadById");
      }


      var pathParams = {
        id: id,
      };
      var queryParams = {
        userId: opts['userId'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['appToken', 'userToken'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Actividades;

      return this.apiClient.callApi(
        '/Actividades/{id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    };

    /**
     * Get one Actividad.
     * Get one Actividades.
     * @param {String} id id to delete
     * @param {Object} opts Optional parameters
     * @param {String} opts.userId id of user. Only for admin users.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:models/Actividades}
     */
    this.getActividadById = function(id, opts) {
      return this.getActividadByIdWithHttpInfo(id, opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    };


    /**
     * Get all Actividades.
     * Get all Actividades.
     * @param {Number} skip number of item to skip (not included the first)
     * @param {Number} limit max records to return (included the last)
     * @param {Object} opts Optional parameters
     * @param {String} opts.orderBy order by property. Put &#39;-&#39; at the beginning to descendant order.
     * @param {String} opts.filter filter data. NOT SUPPORTED YET.
     * @param {String} opts.userId id of user. Only for admin users.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link Array.<module:models/Vacas>} and HTTP response
     */
    this.getActividadesWithHttpInfo = function(skip, limit, opts) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'skip' is set
      if (skip === undefined || skip === null) {
        throw new Error("Missing the required parameter 'skip' when calling getActividades");
      }

      // verify the required parameter 'limit' is set
      if (limit === undefined || limit === null) {
        throw new Error("Missing the required parameter 'limit' when calling getActividades");
      }


      var pathParams = {
      };
      var queryParams = {
        skip: skip,
        limit: limit,
        orderBy: opts['orderBy'],
        filter: opts['filter'],
        userId: opts['userId'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['appToken', 'userToken'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = [Vacas];

      return this.apiClient.callApi(
        '/Actividades', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    };

    /**
     * Get all Actividades.
     * Get all Actividades.
     * @param {Number} skip number of item to skip (not included the first)
     * @param {Number} limit max records to return (included the last)
     * @param {Object} opts Optional parameters
     * @param {String} opts.orderBy order by property. Put &#39;-&#39; at the beginning to descendant order.
     * @param {String} opts.filter filter data. NOT SUPPORTED YET.
     * @param {String} opts.userId id of user. Only for admin users.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link Array.<module:models/Vacas>}
     */
    this.getActividades = function(skip, limit, opts) {
      return this.getActividadesWithHttpInfo(skip, limit, opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    };
  };

  return exports;
}));
