/**
 * Intellidrone API
 * This ios Intellidrone API designed by [Singleton](http://singleton.com.ar).You  can find out more about Swagger at [Singleton Web Page](http://singleton.com.ar) or on [Intellidrone Web Page](http://robotagro.com).
 *
 * OpenAPI spec version: 1.0.0
 * Contact: soporte@singleton.com.ar
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.0
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['/ApiClient', '/models/DeletedResponse', '/models/Error', '/models/Lotes'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../models/DeletedResponse'), require('../models/Error'), require('../models/Lotes'));
  } else {
    // Browser globals (root is window)
    if (!root.intellidrone_api_client_js) {
      root.intellidrone_api_client_js = {};
    }
    root.intellidrone_api_client_js.LotesApi = factory(root.intellidrone_api_client_js.ApiClient, root.intellidrone_api_client_js.DeletedResponse, root.intellidrone_api_client_js.Error, root.intellidrone_api_client_js.Lotes);
  }
}(this, function(ApiClient, DeletedResponse, Error, Lotes) {
  'use strict';

  /**
   * Lotes service.
   * @module /api/LotesApi
   * @version 1.0.0
   */

  /**
   * Constructs a new LotesApi.
   * @alias module:/api/LotesApi
   * @class
   * @param {module:/ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:/ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Add one lote.
     * Add one lote.
     * @param {module:models/Lotes} lote
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:models/Lotes} and HTTP response
     */
    this.addLoteWithHttpInfo = function(lote) {
      var postBody = lote;

      // verify the required parameter 'lote' is set
      if (lote === undefined || lote === null) {
        throw new Error("Missing the required parameter 'lote' when calling addLote");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['appToken', 'userToken'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Lotes;

      return this.apiClient.callApi(
        '/Lotes', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    };

    /**
     * Add one lote.
     * Add one lote.
     * @param {module:models/Lotes} lote
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:models/Lotes}
     */
    this.addLote = function(lote) {
      return this.addLoteWithHttpInfo(lote)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    };


    /**
     * Delete one lote.
     * Delete one lote.
     * @param {String} id id to delete
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:models/DeletedResponse} and HTTP response
     */
    this.deleteLoteWithHttpInfo = function(id) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling deleteLote");
      }


      var pathParams = {
        id: id,
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['appToken', 'userToken'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = DeletedResponse;

      return this.apiClient.callApi(
        '/Lotes/{id}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    };

    /**
     * Delete one lote.
     * Delete one lote.
     * @param {String} id id to delete
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:models/DeletedResponse}
     */
    this.deleteLote = function(id) {
      return this.deleteLoteWithHttpInfo(id)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    };


    /**
     * Edit one lote.
     * Edit one lote.
     * @param {module:models/Lotes} lote
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:models/Lotes} and HTTP response
     */
    this.editLoteWithHttpInfo = function(lote) {
      var postBody = lote;

      // verify the required parameter 'lote' is set
      if (lote === undefined || lote === null) {
        throw new Error("Missing the required parameter 'lote' when calling editLote");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['appToken', 'userToken'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Lotes;

      return this.apiClient.callApi(
        '/Lotes', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    };

    /**
     * Edit one lote.
     * Edit one lote.
     * @param {module:models/Lotes} lote
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:models/Lotes}
     */
    this.editLote = function(lote) {
      return this.editLoteWithHttpInfo(lote)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    };


    /**
     * Get one lote.
     * Get one lote.
     * @param {String} id id to delete
     * @param {Object} opts Optional parameters
     * @param {String} opts.userId id of user. Only for admin users.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:models/Lotes} and HTTP response
     */
    this.getLoteByIdWithHttpInfo = function(id, opts) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling getLoteById");
      }


      var pathParams = {
        id: id,
      };
      var queryParams = {
        userId: opts['userId'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['appToken', 'userToken'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = Lotes;

      return this.apiClient.callApi(
        '/Lotes/{id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    };

    /**
     * Get one lote.
     * Get one lote.
     * @param {String} id id to delete
     * @param {Object} opts Optional parameters
     * @param {String} opts.userId id of user. Only for admin users.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:models/Lotes}
     */
    this.getLoteById = function(id, opts) {
      return this.getLoteByIdWithHttpInfo(id, opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    };


    /**
     * Get all lotes.
     * Get all lotes.
     * @param {Number} skip number of item to skip (not included the first)
     * @param {Number} limit max records to return (included the last)
     * @param {Object} opts Optional parameters
     * @param {String} opts.orderBy order by property. Put &#39;-&#39; at the beginning to descendant order.
     * @param {String} opts.filter filter data. NOT SUPPORTED YET.
     * @param {String} opts.userId id of user. Only for admin users.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link Array.<module:models/Lotes>} and HTTP response
     */
    this.getLotesWithHttpInfo = function(skip, limit, opts) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'skip' is set
      if (skip === undefined || skip === null) {
        throw new Error("Missing the required parameter 'skip' when calling getLotes");
      }

      // verify the required parameter 'limit' is set
      if (limit === undefined || limit === null) {
        throw new Error("Missing the required parameter 'limit' when calling getLotes");
      }


      var pathParams = {
      };
      var queryParams = {
        skip: skip,
        limit: limit,
        orderBy: opts['orderBy'],
        filter: opts['filter'],
        userId: opts['userId'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['appToken', 'userToken'];
      var contentTypes = ['application/json', 'application/xml'];
      var accepts = ['application/json', 'application/xml'];
      var returnType = [Lotes];

      return this.apiClient.callApi(
        '/Lotes', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    };

    /**
     * Get all lotes.
     * Get all lotes.
     * @param {Number} skip number of item to skip (not included the first)
     * @param {Number} limit max records to return (included the last)
     * @param {Object} opts Optional parameters
     * @param {String} opts.orderBy order by property. Put &#39;-&#39; at the beginning to descendant order.
     * @param {String} opts.filter filter data. NOT SUPPORTED YET.
     * @param {String} opts.userId id of user. Only for admin users.
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link Array.<module:models/Lotes>}
     */
    this.getLotes = function(skip, limit, opts) {
      return this.getLotesWithHttpInfo(skip, limit, opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    };
  };

  return exports;
}));
